--train.id, path.is_front
local trains_under_measure = {}

local function measure_train(train)
	closest_stock = trains_under_measure[train.id] and train.front_stock or train.back_stock
	pos = closest_stock.position
	measurement = game.tick .. "|" .. train.id .. "|" .. train.speed .. "|" .. pos.x .. "|" .. pos.y .. "\n"
	game.write_file("train_brake_measure_results.txt", measurement, true)
end

local function changed_state_handler(event)
	local trigger_train = event.train

	if trigger_train == nil then
		return
	end
	
	if not trigger_train.valid then
		trains_under_measure[trigger_train.id] = nil
		return
	end
	
	if trigger_train.state == defines.train_state.arrive_station or	trigger_train.state == defines.train_state.arrive_signal then
		trains_under_measure[trigger_train.id] = trigger_train.path.is_front
		measure_train(trigger_train) --needed here to not miss the first tick in braking state
	elseif trains_under_measure[trigger_train.id] == nil then
		return
	else
		measure_train(trigger_train) --needed here to not miss the last update as it is done after on_tick
		trains_under_measure[trigger_train.id] = nil
	end
end

local function on_tick_handler(event)
	for train_id,_ in pairs(trains_under_measure) do
		train = game.get_train_by_id(train_id)

		if train == nil or not train.valid then
			trains_under_measure[id] = nil
		else
			measure_train(train)
		end
	end
end

script.on_event(defines.events.on_tick, on_tick_handler)
script.on_event(defines.events.on_train_changed_state, changed_state_handler)
